---
title: Pointer events
slug: Web/API/Pointer_events
tags:
  - API
  - Interface
  - Landing
  - Overview
  - Pointer Events
  - Web
  - events
---
<p>{{DefaultAPISidebar("Pointer Events")}}</p>

<p>Much of today's web content assumes the user's pointing device will be a mouse. However, since many devices support other types of pointing input devices, such as pen/stylus and touch surfaces, extensions to the existing pointing device event models are needed. <em><a href="#term_pointer_event">Pointer events</a></em> address that need.</p>

<div class="notecard note">
<p><strong>Note:</strong> Pointer events are <em>not available</em> in <a href="/en-US/docs/Web/API/Web_Workers_API">Web Workers</a>.</p>
</div>

<p>Pointer events are DOM events that are fired for a pointing device. They are designed to create a single DOM event model to handle pointing input devices such as a mouse, pen/stylus or touch (such as one or more fingers).</p>

<p>The <em><a href="#term_pointer">pointer</a></em> is a hardware-agnostic device that can target a specific set of screen coordinates. Having a single event model for pointers can simplify creating Web sites and applications and provide a good user experience regardless of the user's hardware. However, for scenarios when device-specific handling is desired, pointer events defines a {{domxref("PointerEvent.pointerType","pointerType property")}} to inspect the device type which produced the event.</p>

<p>The events needed to handle generic pointer input are analogous to {{domxref("MouseEvent","mouse events")}} (<code>mousedown</code>/<code>pointerdown</code>, <code>mousemove</code>/<code>pointermove</code>, etc.). Consequently, pointer event types are intentionally similar to mouse event types.</p>

<p>Additionally, a pointer event contains the usual properties present in mouse events (client coordinates, target element, button states, etc.) in addition to new properties for other forms of input: pressure, contact geometry, tilt, etc. In fact, the {{domxref("PointerEvent")}} interface inherits all of the {{domxref("MouseEvent")}} properties, thus facilitating the migration of content from mouse events to pointer events.</p>

<h2 id="Terminology">Terminology</h2>

<dl>
 <dt>active buttons state</dt>
 <dd>The condition when a <em><a href="#term_pointer">pointer</a></em> has a non-zero value for the <code>buttons</code> property. For example, in the case of a pen, when the pen has physical contact with the digitizer, or at least one button is depressed while hovering.</dd>
 <dt>active pointer</dt>
 <dd>Any <em><a href="#term_pointer">pointer</a></em> input device that can produce events. A pointer is considered active if it can still produce further events. For example, a pen that is a down state is considered active because it can produce additional events when the pen is lifted or moved.</dd>
 <dt id="term_digitizer">digitizer</dt>
 <dd>A sensing device with a surface that can detect contact. Most commonly, the sensing device is a touch-enabled screen that can sense input from an input device such as a pen, stylus, or finger. Some sensing devices can detect the close proximity of the input device, and the state is expressed as a hover following the mouse.</dd>
 <dt id="term_hit_test">hit test</dt>
 <dd>The process the browser uses to determine a target element for a pointer event. Typically, this is determined by considering the pointer's location and also the visual layout of elements in a document on screen media.</dd>
 <dt id="term_pointer">pointer</dt>
 <dd>A hardware-agnostic representation of input devices that can target a specific coordinate (or set of coordinates) on a screen. Examples of <em>pointer</em> input devices are mouse, pen/stylus, and touch contacts.</dd>
 <dt>pointer capture</dt>
 <dd>Pointer capture allows the events for a pointer to be retargeted to a particular element other than the normal hit test result of the pointer's location.</dd>
 <dt id="term_pointer_event">pointer event</dt>
 <dd>A DOM {{domxref("PointerEvent","event")}} fired for a <em><a href="#term_pointer">pointer</a></em>.</dd>
</dl>

<h2 id="Interfaces">Interfaces</h2>

<p>The primary interface is the {{domxref("PointerEvent")}} interface which has a {{domxref("PointerEvent.PointerEvent","constructor")}} plus several event types and associated global event handlers.</p>

<p>The standard also includes some extensions to the {{domxref("Element")}} and {{domxref("Navigator")}} interfaces.</p>

<p>The following sub-sections contain short descriptions of each interface and property.</p>

<h3 id="PointerEvent_interface">PointerEvent interface</h3>

<p>The {{domxref("PointerEvent")}} interface extends the {{domxref("MouseEvent")}} interface and has the following properties. (All of the following properties are {{readonlyInline}}.)</p>

<dl>
 <dt>{{ domxref('PointerEvent.pointerId','pointerId')}}</dt>
 <dd>A unique identifier for the pointer causing the event.</dd>
 <dt>{{ domxref('PointerEvent.width','width')}}</dt>
 <dd>The width (magnitude on the X axis), in CSS pixels, of the contact geometry of the pointer.</dd>
 <dt>{{ domxref('PointerEvent.height','height')}}</dt>
 <dd>the height (magnitude on the Y axis), in CSS pixels, of the contact geometry of the pointer.</dd>
 <dt>{{ domxref('PointerEvent.pressure','pressure')}}</dt>
 <dd>the normalized pressure of the pointer input in the range of <code>0</code> to <code>1</code>, where <code>0</code> and <code>1</code> represent the minimum and maximum pressure the hardware is capable of detecting, respectively.</dd>
 <dt>{{ domxref('PointerEvent.tangentialPressure','tangentialPressure')}}</dt>
 <dd>The normalized tangential pressure of the pointer input (also known as barrel pressure or cylinder stress) in the range <code>-1</code> to <code>1</code>, where <code>0</code> is the neutral position of the control.</dd>
 <dt>{{ domxref('PointerEvent.tiltX','tiltX')}}</dt>
 <dd>The plane angle (in degrees, in the range of <code>-90</code> to <code>90</code>) between the Y–Z plane and the plane containing both the pointer (e.g. pen stylus) axis and the Y axis.</dd>
 <dt>{{ domxref('PointerEvent.tiltY','tiltY')}}</dt>
 <dd>the plane angle (in degrees, in the range of <code>-90</code> to <code>90</code>) between the X–Z plane and the plane containing both the pointer (e.g. pen stylus) axis and the X axis.</dd>
 <dt>{{ domxref('PointerEvent.twist','twist')}}</dt>
 <dd>The clockwise rotation of the pointer (e.g. pen stylus) around its major axis in degrees, with a value in the range <code>0</code> to <code>359</code>.</dd>
 <dt>{{ domxref('PointerEvent.pointerType','pointerType')}}</dt>
 <dd>Indicates the device type that caused the event (mouse, pen, touch, etc.)</dd>
 <dt>{{ domxref('PointerEvent.isPrimary','isPrimary')}}</dt>
 <dd>Indicates if the pointer represents the primary pointer of this pointer type.</dd>
</dl>

<h3 id="Event_types_and_Global_Event_Handlers">Event types and Global Event Handlers</h3>

<p>Pointer events have ten event types, seven of which have similar semantics to their mouse event counterparts (<code>down</code>, <code>up</code>, <code>move</code>, <code>over</code>, <code>out</code>, <code>enter</code>, and <code>leave</code>).</p>

<p>Below is a short description of each event type and its associated {{domxref("GlobalEventHandlers","Global Event Handler")}}.</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Event</th>
   <th scope="col">On Event Handler</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{event('pointerover')}}</td>
   <td>{{domxref('GlobalEventHandlers.onpointerover','onpointerover')}}</td>
   <td>Fired when a pointer is moved into an element's <a href="#term_hit_test">hit test</a> boundaries.</td>
  </tr>
  <tr>
   <td>{{event('pointerenter')}}</td>
   <td>{{domxref('GlobalEventHandlers.onpointerenter','onpointerenter')}}</td>
   <td>Fired when a pointer is moved into the <a href="#term_hit_test">hit test</a> boundaries of an element or one of its descendants, including as a result of a pointerdown event from a device that does not support hover (see <code>pointerdown</code>).</td>
  </tr>
  <tr>
   <td>{{event('pointerdown')}}</td>
   <td>{{domxref('GlobalEventHandlers.onpointerdown','onpointerdown')}}</td>
   <td>Fired when a pointer becomes <em>active buttons state</em>.</td>
  </tr>
  <tr>
   <td>{{event('pointermove')}}</td>
   <td>{{domxref('GlobalEventHandlers.onpointermove','onpointermove')}}</td>
   <td>Fired when a pointer changes coordinates. This event is also used if the change in pointer state can not be reported by other events.</td>
  </tr>
  <tr>
   <td>{{event('pointerup')}}</td>
   <td>{{domxref('GlobalEventHandlers.onpointerup','onpointerup')}}</td>
   <td>Fired when a pointer is no longer <em>active buttons state</em>.</td>
  </tr>
  <tr>
   <td>{{event('pointercancel')}}</td>
   <td>{{domxref('GlobalEventHandlers.onpointercancel','onpointercancel')}}</td>
   <td>A browser fires this event if it concludes the pointer will no longer be able to generate events (for example the related device is deactived).</td>
  </tr>
  <tr>
   <td>{{event('pointerout')}}</td>
   <td>{{domxref('GlobalEventHandlers.onpointerout','onpointerout')}}</td>
   <td>Fired for several reasons including: pointer is moved out of the <a href="#term_hit_test">hit test</a> boundaries of an element; firing the pointerup event for a device that does not support hover (see pointerup); after firing the <code>pointercancel</code> event (see <code>pointercancel</code>); when a pen stylus leaves the hover range detectable by the digitizer.</td>
  </tr>
  <tr>
   <td>{{event('pointerleave')}}</td>
   <td>{{domxref('GlobalEventHandlers.onpointerleave','onpointerleave')}}</td>
   <td>Fired when a pointer is moved out of the <a href="#term_hit_test">hit test</a> boundaries of an element. For pen devices, this event is fired when the stylus leaves the hover range detectable by the digitizer.</td>
  </tr>
  <tr>
   <td>{{event('gotpointercapture')}}</td>
   <td>{{domxref('GlobalEventHandlers.ongotpointercapture','ongotpointercapture')}}</td>
   <td>Fired when an element receives pointer capture.</td>
  </tr>
  <tr>
   <td>{{event('lostpointercapture')}}</td>
   <td>{{domxref('GlobalEventHandlers.onlostpointercapture','onlostpointercapture')}}</td>
   <td>Fired after pointer capture is released for a pointer.</td>
  </tr>
 </tbody>
</table>

<h3 id="Element_extensions">Element extensions</h3>

<p>There are three extensions to the {{domxref("Element")}} interface:</p>

<dl>
 <dt>{{domxref("Element.setPointerCapture()","setPointerCapture()")}}</dt>
 <dd>Designates a specific element as the <em>capture target</em> of future pointer events.</dd>
 <dt>{{domxref("Element.releasePointerCapture()","releasePointerCapture()")}}</dt>
 <dd>This method releases (stops) <em>pointer capture</em> that was previously set for a specific pointer event.</dd>
</dl>

<h3 id="Navigator_extension">Navigator extension</h3>

<p>The {{domxref("Navigator.maxTouchPoints")}} property is used to determine the maximum number of simultaneous touch points that are supported at any single point in time.</p>

<h2 id="Examples">Examples</h2>

<p>This section contains examples of basic usage of using the pointer events interfaces.</p>

<h3 id="Registering_event_handlers">Registering event handlers</h3>

<p>This example registers a handler for every event type for the given element.</p>

<pre class="brush: html notranslate">&lt;html&gt;
  &lt;script&gt;
    function over_handler(event) { }
    function enter_handler(event) { }
    function down_handler(event) { }
    function move_handler(event) { }
    function up_handler(event) { }
    function cancel_handler(event) { }
    function out_handler(event) { }
    function leave_handler(event) { }
    function gotcapture_handler(event) { }
    function lostcapture_handler(event) { }

    function init() {
      var el=document.getElementById("target");
      // Register pointer event handlers
      el.onpointerover = over_handler;
      el.onpointerenter = enter_handler;
      el.onpointerdown = down_handler;
      el.onpointermove = move_handler;
      el.onpointerup = up_handler;
      el.onpointercancel = cancel_handler;
      el.onpointerout = out_handler;
      el.onpointerleave = leave_handler;
      el.gotpointercapture = gotcapture_handler;
      el.lostpointercapture = lostcapture_handler;
    }
  &lt;/script&gt;
  &lt;body onload="init();"&gt;
    &lt;div id="target"&gt; Touch me ... &lt;/div&gt;
  &lt;/body&gt;
&lt;/html&gt;
</pre>

<h3 id="Event_properties">Event properties</h3>

<p>This example illustrates accessing all of a touch event's properties.</p>

<pre class="brush: html notranslate">&lt;html&gt;
  &lt;script&gt;
    var id = -1;

    function process_id(event) {
      // Process this event based on the event's identifier
    }
    function process_mouse(event) {
      // Process the mouse pointer event
    }
    function process_pen(event) {
      // Process the pen pointer event
    }
    function process_touch(event) {
      // Process the touch pointer event
    }
    function process_tilt(tiltX, tiltY) {
      // Tilt data handler
    }
    function process_pressure(pressure) {
      // Pressure handler
    }
    function process_non_primary(event) {
      // Non primary handler
    }

    function down_handler(ev) {
      // Calculate the touch point's contact area
      var area = ev.width * ev.height;

      // Compare cached id with this event's id and process accordingly
      if (id == ev.identifier) process_id(ev);

      // Call the appropriate pointer type handler
      switch (ev.pointerType) {
        case "mouse":
          process_mouse(ev);
          break;
        case "pen":
          process_pen(ev);
          break;
        case "touch":
          process_touch(ev);
          break;
        default:
          console.log("pointerType " + ev.pointerType + " is Not suported");
      }

      // Call the tilt handler
      if (ev.tiltX != 0 &amp;&amp; ev.tiltY != 0) process_tilt(ev.tiltX, ev.tiltY);

      // Call the pressure handler
      process_pressure(ev.pressure);

      // If this event is not primary, call the non primary handler
      if (!ev.isPrimary) process_non_primary(ev);
    }

    function init() {
      var el=document.getElementById("target");
      // Register pointerdown handler
      el.onpointerdown = down_handler;
    }
  &lt;/script&gt;
  &lt;body onload="init();"&gt;
    &lt;div id="target"&gt; Touch me ... &lt;/div&gt;
  &lt;/body&gt;
&lt;/html&gt;
</pre>

<h2 id="Determining_the_Primary_Pointer">Determining the Primary Pointer</h2>

<p>In some scenarios there may be multiple pointers (for example a device with both a touchscreen and a mouse) or a pointer supports multiple contact points (for example a touchscreen that supports multiple finger touches). The application can use the {{domxref("PointerEvent.isPrimary","isPrimary")}} property to identify a master pointer among the set of <em>active pointers</em> for each pointer type. If an application only wants to support a primary pointer, it can ignore all pointer events that are not primary.</p>

<p>For mouse there is only one pointer, so it will always be the primary pointer. For touch input, a pointer is considered primary if the user touched the screen when there were no other active touches. For pen and stylus input, a pointer is considered primary if the user's pen initially contacted the screen when there were no other active pens contacting the screen.</p>

<h2 id="Determining_button_states">Determining button states</h2>

<p>Some pointer devices, such as mouse and pen, support multiple buttons and the button presses can be <em>chorded</em> i.e. depressing an additional button while another button on the pointer device is already depressed.</p>

<p>To determine the state of button presses, pointer events uses the {{domxref("MouseEvent.button","button")}} and {{domxref("MouseEvent.buttons","buttons")}} properties of the {{domxref("MouseEvent")}} interface (that {{domxref("PointerEvent")}} inherits from).</p>

<p>The following table provides the values of <code>button</code> and <code>buttons</code> for the various device button states.</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Device Button State</th>
   <th scope="col">button</th>
   <th scope="col">buttons</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>Neither buttons nor touch/pen contact changed since last event</td>
   <td><code>-1</code></td>
   <td>—</td>
  </tr>
  <tr>
   <td>Mouse move with no buttons pressed, Pen moved while hovering with no buttons pressed</td>
   <td>—</td>
   <td><code>0</code></td>
  </tr>
  <tr>
   <td>Left Mouse, Touch Contact, Pen contact</td>
   <td><code>0</code></td>
   <td><code>1</code></td>
  </tr>
  <tr>
   <td>Middle Mouse</td>
   <td><code>1</code></td>
   <td><code>4</code></td>
  </tr>
  <tr>
   <td>Right Mouse, Pen barrel button</td>
   <td><code>2</code></td>
   <td><code>2</code></td>
  </tr>
  <tr>
   <td>X1 (back) Mouse</td>
   <td><code>3</code></td>
   <td><code>8</code></td>
  </tr>
  <tr>
   <td>X2 (forward) Mouse</td>
   <td><code>4</code></td>
   <td><code>16</code></td>
  </tr>
  <tr>
   <td>Pen eraser button</td>
   <td><code>5</code></td>
   <td><code>32</code></td>
  </tr>
 </tbody>
</table>

<div class="notecard note">
<p><strong>Notice:</strong> The <code>button</code> property indicates a change in the state of the button. However, as in the case of touch, when multiple events occur with one event, all of them have the same value.</p>
</div>

<h2 id="Pointer_capture">Pointer capture</h2>

<p>Pointer capture allows events for a particular {{domxref("PointerEvent","pointer event")}} to be re-targeted to a particular element instead of the normal <a href="#term_hit_test">hit test</a> at a pointer's location. This can be used to ensure that an element continues to receive pointer events even if the pointer device's contact moves off the element (for example by scrolling).</p>

<p>The following example shows pointer capture being set on an element.</p>

<pre class="brush: html notranslate">&lt;html&gt;
&lt;script&gt;
  function downHandler(ev) {
    let el = document.getElementById("target");
    // Element 'target' will receive/capture further events
    el.setPointerCapture(ev.pointerId);
  }

  function init() {
    let el = document.getElementById("target");
    el.onpointerdown = downHandler;
  }
&lt;/script&gt;
&lt;body onload="init();"&gt;
  &lt;div id="target"&gt; Touch me ... &lt;/div&gt;
&lt;/body&gt;
&lt;/html&gt;
</pre>

<p>The following example shows a pointer capture being released (when a {{event("pointercancel")}} event occurs. The browser does this automatically when a {{event("pointerup")}} or {{event("pointercancel")}} event occurs.</p>

<pre class="brush: html notranslate">&lt;html&gt;
  &lt;script&gt;
    function downHandler(ev) {
      let el = document.getElementById("target");
      // Element "target" will receive/capture further events
      el.setPointerCapture(ev.pointerId);
    }

    function cancelHandler(ev) {
      let el = document.getElementById("target");
      // Release the pointer capture
      el.releasePointerCapture(ev.pointerId);
    }

    function init() {
      let el = document.getElementById("target");
      // Register pointerdown and pointercancel handlers
      el.onpointerdown = downHandler;
      el.onpointercancel = cancelHandler;
    }
  &lt;/script&gt;
  &lt;body onload="init();"&gt;
    &lt;div id="target"&gt; Touch me ... &lt;/div&gt;
  &lt;/body&gt;
&lt;/html&gt;
</pre>

<h2 id="touch-action_CSS_property">touch-action CSS property</h2>

<p>The {{cssxref("touch-action")}} CSS property is used to specify whether or not the browser should apply its default (<em>native</em>) touch behavior (such as zooming or panning) to a region. This property may be applied to all elements except: non-replaced inline elements, table rows, row groups, table columns, and column groups.</p>

<p>A value of <code>auto</code> means the browser is free to apply its default touch behavior (to the specified region) and the value of <code>none</code> disables the browser's default touch behavior for the region. The values <code>pan-x</code> and <code>pan-y</code>, mean that touches that begin on the specified region are only for horizontal and vertical scrolling, respectively. The value <code>manipulation</code> means the browser may consider touches that begin on the element are only for scrolling and zooming.</p>

<p>In the following example, the browser's default touch behavior is disabled for the <code>div</code> element.</p>

<pre class="brush: html notranslate">&lt;html&gt;
  &lt;body&gt;
    &lt;div style="touch-action:none;"&gt;Can't touch this ... &lt;/div&gt;
  &lt;/body&gt;
&lt;/html&gt;
</pre>

<p>In the following example, default touch behavior is disabled for some <code>button</code> elements.</p>

<pre class="brush: css notranslate">button#tiny {
  touch-action: none;
}
</pre>

<p>In the following example, when the <code>target</code> element is touched, it will only pan in the horizontal direction.</p>

<pre class="brush: css notranslate">#target {
  touch-action: pan-x;
}
</pre>

<h2 id="Compatibility_with_mouse_events">Compatibility with mouse events</h2>

<p>Although the pointer event interfaces enable applications to create enhanced user experiences on pointer enabled devices, the reality is the vast majority of today's web content is designed to only work with mouse input. Consequently, even if a browser supports pointer events, the browser must still process mouse events so content that assumes mouse-only input will work as is without direct modification. Ideally, a pointer enabled application does not need to explicitly handle mouse input. However, because the browser must process mouse events, there may be some compatibility issues that need to be handled. This section contains information about pointer event and mouse event interaction and the ramifications for application developers.</p>

<p>The browser <em>may map generic pointer input to mouse events for compatibility with mouse-based content</em>. This mapping of events is called <em>compatibility mouse events</em>. Authors can prevent the production of certain compatibility mouse events by canceling the pointerdown event but note that:</p>

<ul>
 <li>Mouse events can only be prevented when the pointer is down.</li>
 <li>Hovering pointers (e.g. a mouse with no buttons pressed) cannot have their mouse events prevented.</li>
 <li>The <code>mouseover</code>, <code>mouseout</code>, <code>mouseenter</code>, and <code>mouseleave</code> events are never prevented (even if the pointer is down).</li>
</ul>

<h2 id="Best_practices">Best practices</h2>

<p>Here are some <em>best practices</em> to consider when using pointer events:</p>

<ul>
 <li>Minimize the amount of work performed in event handlers.</li>
 <li>Add the event handlers to a specific target element (rather than the entire document or nodes higher up in the document tree).</li>
 <li>The target element (node) should be large enough to accommodate the largest contact surface area (typically a finger touch). If the target area is too small, touching it could result in firing other events for adjacent elements.</li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Pointer Events 3')}}</td>
   <td>{{Spec2('Pointer Events 3')}}</td>
   <td>Added new APIs for <code>getCoalescedEvent</code> and <code>getPredictedEvents</code>, new <code>pointerrawupdate</code> event, additional <code>touch-action</code> property values <code>pan-left</code>, <code>pan-right</code>, <code>pan-up</code>, <code>pan-down</code>.</td>
  </tr>
  <tr>
   <td>{{SpecName('Pointer Events 2')}}</td>
   <td>{{Spec2('Pointer Events 2')}}</td>
   <td>Adds <code>hasPointerCapture</code> method and clarifies more edge cases and dynamic scenarios. </td>
  </tr>
  <tr>
   <td>{{SpecName('Pointer Events')}}</td>
   <td>{{Spec2('Pointer Events')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility"><span>Browser compatibility</span></h2>

<div class="hidden">
<p>The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<p>{{Compat("api.PointerEvent")}}</p>

<p>Some new values have been defined for the {{cssxref("touch-action", "CSS touch-action")}} property as part of the {{SpecName('Pointer Events 3')}} specification but currently those new values have limited implementation support.</p>

<h2 id="Demos_and_examples">Demos and examples</h2>

<ul>
 <li><a href="https://patrickhlauke.github.io/touch/">Touch/pointer tests and demos (by Patrick H. Lauke)</a></li>
</ul>

<h2 id="Community">Community</h2>

<ul>
 <li><a href="https://github.com/w3c/pointerevents">Pointer Events Working Group</a></li>
 <li><a href="http://lists.w3.org/Archives/Public/public-pointer-events/">Mail list</a></li>
 <li><a href="irc://irc.w3.org:6667/">W3C #pointerevents IRC channel</a></li>
</ul>

<h2 id="Related_topics_and_resources">Related topics and resources</h2>

<ul>
 <li><a href="http://www.w3.org/TR/touch-events/">Touch Events Standard</a></li>
</ul>
